--- old/usr/src/pkg/manifests/system-test-ostest.p5m	Wed Apr 12 20:33:27 2023
+++ new/usr/src/pkg/manifests/system-test-ostest.p5m	Wed Apr 12 20:33:27 2023
@@ -66,6 +66,8 @@
 file path=opt/os-tests/tests/file-locking/acquire-lock.64 mode=0555
 file path=opt/os-tests/tests/file-locking/runtests.32 mode=0555
 file path=opt/os-tests/tests/file-locking/runtests.64 mode=0555
+file path=opt/os-tests/tests/getcontext_extd.32 mode=0555
+file path=opt/os-tests/tests/getcontext_extd.64 mode=0555
 $(i386_ONLY)dir path=opt/os-tests/tests/i386
 $(i386_ONLY)file path=opt/os-tests/tests/i386/badseg mode=0555
 $(i386_ONLY)file path=opt/os-tests/tests/i386/badseg_exec mode=0555
@@ -176,6 +178,57 @@
 file path=opt/os-tests/tests/ucontext.64 mode=0555
 file path=opt/os-tests/tests/writev.32 mode=0555
 file path=opt/os-tests/tests/writev.64 mode=0555
+$(i386_ONLY)dir path=opt/os-tests/tests/xsave
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/bad_xregs.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/bad_xregs.64 mode=0555
+$(i386_ONLY)dir path=opt/os-tests/tests/xsave/data
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/mdb_xregs.ymm.32 mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/mdb_xregs.ymm.64 mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/mdb_xregs.zmm.32 mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/mdb_xregs.zmm.64 mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.fpregs.ymm.32 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.fpregs.ymm.64 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.fpregs.zmm.32 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.fpregs.zmm.64 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.xregs.ymm.32 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.xregs.ymm.64 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.xregs.zmm.32 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/data/proc_writes.xregs.zmm.64 \
+    mode=0444
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/fpregs.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/fpregs.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/fpregs_xbv.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/fpregs_xbv.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/mdb_xregs mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/proc_writes mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/proc_xregs_set.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/proc_xregs_set.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/setcontext_replace.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/setcontext_replace.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/setcontext_restore.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/setcontext_restore.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/signal_restore.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/signal_restore.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/swapcontext_extd.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/swapcontext_extd.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xregs_dump.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xregs_dump.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xregs_roundtrip.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xregs_roundtrip.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xregs_set.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xregs_set.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xsave_baducontext mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xsave_baducontext.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xsave_baducontext.64 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xsu_hwtype.32 mode=0555
+$(i386_ONLY)file path=opt/os-tests/tests/xsave/xsu_hwtype.64 mode=0555
 file path=opt/os-tests/tests/zen_umc_test mode=0555
 license cr_Sun license=cr_Sun
 license lic_CDDL license=lic_CDDL
--- old/usr/src/test/os-tests/runfiles/default.run	Wed Apr 12 20:33:27 2023
+++ new/usr/src/test/os-tests/runfiles/default.run	Wed Apr 12 20:33:27 2023
@@ -41,6 +41,8 @@
 
 [/opt/os-tests/tests/ucontext.32]
 [/opt/os-tests/tests/ucontext.64]
+[/opt/os-tests/tests/getcontext_extd.32]
+[/opt/os-tests/tests/getcontext_extd.64]
 
 [/opt/os-tests/tests/secflags]
 user = root
@@ -159,3 +161,23 @@
 	'illumos-15031',
 	'illumos-15036'
 	]
+
+#
+# The following tests all represent tests that require the xsave feature
+# set. These are all x86 specific. The use of arch=i86pc below doesn't
+# really represent things that can be run on x86 regardless of the
+# platform and when the test runner gains support for specifying that,
+# use that instead. This would be split into two groups, but that isn't
+# supported, so everything ends up being run as root for the sake of the
+# xsave_baducontext test.
+#
+[/opt/os-tests/tests/xsave]
+arch = i86pc
+pre = xsu_hwtype.64
+user = root
+tests = [ 'bad_xregs.32', 'bad_xregs.64', 'mdb_xregs', 'proc_writes',
+    'setcontext_replace.32', 'setcontext_replace.64', 'setcontext_restore.32',
+    'setcontext_restore.64', 'signal_restore.32', 'signal_restore.64',
+    'xregs_roundtrip.32', 'xregs_roundtrip.64', 'xsave_baducontext',
+    'fpregs_xbv.32', 'fpregs_xbv.64', 'swapcontext_extd.32',
+    'swapcontext_extd.64' ]
--- old/usr/src/test/os-tests/tests/Makefile	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/Makefile	Wed Apr 12 20:33:28 2023
@@ -17,7 +17,7 @@
 # Copyright 2023 Oxide Computer Company
 #
 
-SUBDIRS_i386 = i386 imc zen_umc
+SUBDIRS_i386 = i386 imc zen_umc xsave
 
 SUBDIRS =       \
 		cores \
@@ -50,6 +50,7 @@
 	odirectory \
 	OS-6097 \
 	ucontext \
+	getcontext_extd \
 	writev
 
 CPPFLAGS += -D_REENTRANT
--- /dev/null	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/getcontext_extd.c	Wed Apr 12 20:33:28 2023
@@ -0,0 +1,117 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2023 Oxide Computer Company
+ */
+
+/*
+ * Basic test for getcontext_extd() variant. We have two cases that we need to
+ * consider. A ucontext_t that is allocated and initialized from the stack and
+ * then one that comes from a ucontext_alloc(). We test both that setcontext()
+ * and makecontext() work with these.
+ */
+
+#include <ucontext.h>
+#include <unistd.h>
+#include <stdlib.h>
+#include <err.h>
+#include <string.h>
+#include <errno.h>
+#include <upanic.h>
+
+#define	STACK_MAGIC	42
+#define	EXIT_MAGIC	23
+static volatile uint32_t count = 0;
+static volatile uint32_t stack_count = 0;
+
+static void
+successful_exit(uint32_t test)
+{
+	if (test != EXIT_MAGIC) {
+		errx(EXIT_FAILURE, "TEST FAILED: makecontext had wrong "
+		    "argument, found 0x%x, expected 0x%x", test, EXIT_MAGIC);
+	}
+
+	printf("TEST PASSED: makecontext called with right argument\n");
+	exit(0);
+}
+
+static void
+getcontext_stack(uint32_t test)
+{
+	ucontext_t ctx;
+
+	if (test != STACK_MAGIC) {
+		errx(EXIT_FAILURE, "TEST FAILED: makecontext had wrong "
+		    "argument, found 0x%x, expected 0x%x", test, STACK_MAGIC);
+	}
+
+	(void) memset(&ctx, 0, sizeof (ctx));
+
+	if (getcontext_extd(&ctx, 0) != 0) {
+		err(EXIT_FAILURE, "failed to get extended context from stack");
+	}
+
+	count++;
+	if (count < 5) {
+		const char *msg = "stack setcontext returned, sorry";
+		(void) setcontext(&ctx);
+		upanic(msg, strlen(msg) + 1);
+	}
+
+	(void) printf("TEST PASSED: stack ucontext_t / getcontext_extd() / "
+	    "setcontext() combo worked\n");
+	makecontext(&ctx, successful_exit, 1, EXIT_MAGIC);
+	(void) setcontext(&ctx);
+
+	err(EXIT_FAILURE, "TEST FAILED: stack ucontext_t / makecontext() "
+	    "returned from setcontext()");
+}
+
+int
+main(void)
+{
+	ucontext_t *ctx = ucontext_alloc(0);
+	if (ctx == NULL) {
+		err(EXIT_FAILURE, "failed to get allocate ucontext_t");
+	}
+
+	if (getcontext_extd(ctx, 23) == 0) {
+		errx(EXIT_FAILURE, "TEST FAILED: getcontext_extd worked with "
+		    "bad flags");
+	}
+
+	if (errno != EINVAL) {
+		errx(EXIT_FAILURE, "TEST FAILED: getcontext_extd returned "
+		    "wrong errno for bad flags: 0x%x", errno);
+	}
+
+	if (getcontext_extd(ctx, 0) != 0) {
+		err(EXIT_FAILURE, "failed to get extended context");
+	}
+
+	count++;
+	if (count < 5) {
+		const char *msg = "setcontext returned, sorry";
+		(void) setcontext(ctx);
+		upanic(msg, strlen(msg) + 1);
+	}
+
+	(void) printf("TEST PASSED: ucontext_alloc() / getcontext_extd() / "
+	    "setcontext() combo worked\n");
+	makecontext(ctx, getcontext_stack, 1, STACK_MAGIC);
+	(void) setcontext(ctx);
+
+	warn("TEST FAILED: failed to setcontext() to makecontext() from "
+	    "ucontext_alloc() / getcontext_extd()");
+	return (EXIT_FAILURE);
+}
--- /dev/null	Wed Apr 12 20:33:28 2023
+++ new/usr/src/test/os-tests/tests/xsave/Makefile	Wed Apr 12 20:33:28 2023
@@ -0,0 +1,145 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2023 Oxide Computer Company
+#
+
+PROGS = \
+	bad_xregs \
+	fpregs \
+	fpregs_xbv \
+	proc_xregs_set \
+	setcontext_replace \
+	setcontext_restore \
+	swapcontext_extd \
+	signal_restore \
+	xregs_dump \
+	xregs_roundtrip \
+	xregs_set \
+	xsave_baducontext \
+	xsu_hwtype
+
+SCRIPTS = mdb_xregs proc_writes xsave_baducontext
+
+DATAFILES = \
+	mdb_xregs.ymm.32 \
+	mdb_xregs.ymm.64 \
+	mdb_xregs.zmm.32 \
+	mdb_xregs.zmm.64 \
+	proc_writes.fpregs.ymm.32 \
+	proc_writes.fpregs.ymm.64 \
+	proc_writes.fpregs.zmm.32 \
+	proc_writes.fpregs.zmm.64 \
+	proc_writes.xregs.ymm.32 \
+	proc_writes.xregs.ymm.64 \
+	proc_writes.xregs.zmm.32 \
+	proc_writes.xregs.zmm.64
+
+PROGS32 = $(PROGS:%=%.32)
+PROGS64 = $(PROGS:%=%.64)
+
+ROOTOPTDIR = $(ROOT)/opt/os-tests/tests
+ROOTOPTXSAVE = $(ROOTOPTDIR)/xsave
+ROOTOPTPROGS = $(PROGS32:%=$(ROOTOPTXSAVE)/%) \
+	$(PROGS64:%=$(ROOTOPTXSAVE)/%) \
+	$(SCRIPTS:%=$(ROOTOPTXSAVE)/%)
+ROOTOPTDATADIR = $(ROOTOPTXSAVE)/data
+ROOTOPTDATA = $(DATAFILES:%=$(ROOTOPTDATADIR)/%)
+
+COMMOBJS32 = xsave_util.32.o xsave_asm32.32.o
+COMMOBJS64 = xsave_util.64.o xsave_asm64.64.o
+
+OBJS32 = $(COMMOBJS32) $(PROGS:%=%.32.o)
+OBJS64 = $(COMMOBJS64) $(PROGS:%=%.64.o)
+
+#
+# To simplify things we always link in the support files to programs
+# even though in some case (e.g. xsave_baducontext) they aren't needed.
+# This also drives a requirement that everything links against libproc
+# (seen below).
+#
+EXTRA_OBJS32 = $(COMMOBJS32)
+EXTRA_OBJS64 = $(COMMOBJS64)
+
+include $(SRC)/cmd/Makefile.cmd
+
+#
+# These are required to get COMPILE.s to work as Makefile.master puts
+# some things in AS_CPPFLAGS, but not what we need to make it work.
+#
+AS_CPPFLAGS += -D_ASM
+
+$(ROOTOPTDATA) := FILEMODE = 0444
+
+LDLIBS += -lproc
+LDLIBS64 += -lproc
+
+CSTD = $(GNU_C99)
+
+.KEEP_STATE:
+
+all: $(PROGS32) $(PROGS64)
+
+install: $(ROOTOPTPROGS) $(ROOTOPTDATA)
+
+clean:
+	$(RM) $(OBJS32) $(OBJS64)
+
+$(PROGS32): $(OBJS32)
+$(PROGS64): $(OBJS64)
+
+$(ROOTOPTPROGS): $(PROGS32) $(PROGS64) $(ROOTOPTXSAVE)
+$(ROOTOPTDATA): $(ROOTOPTDATADIR)
+
+$(ROOTOPTDIR):
+	$(INS.dir)
+
+$(ROOTOPTXSAVE): $(ROOTOPTDIR)
+	$(INS.dir)
+
+$(ROOTOPTDATADIR): $(ROOTOPTXSAVE)
+	$(INS.dir)
+
+$(ROOTOPTXSAVE)/%: %
+	$(INS.file)
+
+$(ROOTOPTXSAVE)/%: %.ksh
+	$(INS.rename)
+
+%.32.o: %.c
+	$(COMPILE.c) -o $@ $<
+	$(POST_PROCESS_O)
+
+%.64.o: %.c
+	$(COMPILE64.c) -o $@ $<
+	$(POST_PROCESS_O)
+
+%.32.o: %.S
+	$(COMPILE.s) -o $@ $<
+	$(POST_PROCESS_S_0)
+
+%.64.o: %.S
+	$(COMPILE64.s) -o $@ $<
+	$(POST_PROCESS_S_0)
+
+%.64: %.64.o
+	$(LINK64.c) -o $@ $< $(LDLIBS64) $(EXTRA_OBJS64)
+	$(POST_PROCESS)
+
+%.32: %.32.o
+	$(LINK.c) -o $@ $< $(LDLIBS) $(EXTRA_OBJS32)
+	$(POST_PROCESS)
+
+clobber: clean
+	$(RM) $(PROGS32) $(PROGS64)
+
+FRC:
